/*------------------------------------------------------------------------*/
/*--									--*/
/*--	CTL.h								--*/
/*--									--*/
/*--	Header file for share deamon controller.			--*/
/*------------------------------------------------------------------------*/

/*--  Constants  --*/

#define CTL_CONFIG_FILE	"Config.conf"
#define CTL_MAX_TRY	3

#define CTL_ACTIVE	1
#define CTL_SUSPENDED	2
#define CTL_CORRUPT	3



/*--  Command line arguments structure  --*/

struct CTL_ArgsStruc {
  char *ConfigFile;		/* Location of config file		*/
  int  server_num;		/* Share server number			*/
  char HelpFlag;		/* Indicate if help flag is set		*/
};



/*--  CTL Context  --*/

typedef struct ctl_ctx {

  UTL_CTX *utlctx;
  COM_CTX *comctx;
  KEY_CTX *keyctx;
  int timeout;

  int serverID;			/* My server ID				*/

  int status;			/* Server status: active, suspended, or corrupt	*/
} CTL_CTX;



/*--  Function prototypes  --*/

BIGNUM* CTL_get_share(UTL_CTX *utlCtx, RSA_SHARE *key, int coalition, int server);

int CTL_ParseArguments(int argc, char *argv[], struct CTL_ArgsStruc *Args);

int CTL_ConFromServer(CTL_CTX *ctx, COM_STREAM *stream);
int CTL_ConFromClient(CTL_CTX *ctx, COM_STREAM *stream);
int CTL_ConFromAdm(CTL_CTX *ctx, COM_STREAM *stream);

int CTL_SendPublicKey(CTL_CTX *ctx, COM_STREAM *stream, int id, int version);



/*-- Internal CTL Functions --*/

int CTL_Respond(COM_STREAM *stream, int opcode, char *msg);

